#ifndef XY_H
#define XY_H

#include "odb/core.hxx"
#include "odb/lazy-ptr.hxx"

#include <memory>
#include <vector>

struct X;

#pragma db object
struct Y
{
    #pragma db id
    unsigned long id;

    #pragma db value_not_null inverse(ys)
    std::vector<odb::lazy_weak_ptr<X> > xs;
};

#pragma db object
struct X
{
    #pragma db id
    unsigned long id;

    #pragma db value_not_null unordered
    std::vector<odb::lazy_shared_ptr<Y> > ys;
};

#endif
